
public class Fraction
{
    private int numerator;
    private int denominator;
    
    /**
     * @param n ...
     * @param d ... Must not be zero.
     * @throws IllegalArgumentException if denominator is zero
     * @throws ...
     */
    public Fraction(int n, int d) {
        if (d == 0) {
            throw new IllegalArgumentException("d");
        }
        numerator = n;
        denominator = d;
    }
    
    public void setNumerator(int n) {
        numerator = n;
    }
    
    /*
    public boolean setDenominator(int denom) {
        if (denom == 0) {
            return false;
        }
        denominator = denom;
        return true;
    }
    */
   
    public void setDenominator(int denom) {
        if (denom == 0) {
            throw new IllegalArgumentException("denom");
        }
        denominator = denom;
    }
    
    @Override
    public String toString() {
        return numerator + "/" + denominator;
    }
    
    public void add(Fraction fr) {
        int den = fr.denominator;
        // code
    }
}
